#include <stdio.h>
#include <stdlib.h>
#include "/home/mosquitoe/progr/lib/mrand.h"
#include "racio.h"

#define random	mrand

/*
 * Operace: +, -, *, /, ?^x
 *
 * OKOMENTOVAT!!!
 *
 */


P_RACIO a;
P_RACIO b;
P_RACIO c;

typedef struct funkce {
	int vyrizena;
	int zaklad;
	P_RACIO konstanta;
	P_RACIO linearni;
} T_FUNKCE, *P_FUNKCE;

typedef struct otazka {
	P_RACIO id;
	P_FUNKCE pouzite_funkce[50];
	P_RACIO odkazy[4];
	T_FUNKCE funkce[4];
	int defined;
} T_OTAZKA, *P_OTAZKA;



int definovanych_otazek;
int deklarovanych_otazek;


P_OTAZKA pole[50];

int poloha(P_RACIO cislo)
{
	int up, down;
	int c;
	up = deklarovanych_otazek - 1;
	down = 0;
	while (up > down + 1)
	{
		c = r_cmp(cislo, pole[(up + down)/2]->id);
		if (c == 0) return (up+down)/2;
		if (c > 0) down = (up + down)/2;
		if (c < 0) up = (down + up)/2 + (down & up & 1);
	}
	if (!r_cmp(cislo,pole[up]->id)) return up;

	return -1;

}


void vypis_funkci(T_FUNKCE fce)
{
	int zn;
	int plus = 0;
	if (fce.zaklad > 1)
	{
		printf("%d^x",fce.zaklad);
		plus = 1;
	}
	if ((fce.konstanta->citatel != 0) && (fce.konstanta != NULL))
	{
		if (plus && (fce.konstanta->citatel > 0)) printf(" + ");
		if ((fce.konstanta->citatel < 0)) printf(" - ");
		zn = fce.konstanta->citatel;
		fce.konstanta->citatel = abs(fce.konstanta->citatel);
		r_print(fce.konstanta);
		fce.konstanta->citatel = zn;
		plus = 1;
	}
	if ((fce.linearni->citatel != 0) &&(fce.linearni != NULL))
	{
		if (plus && (fce.linearni->citatel > 0)) printf(" + ");
		if ((fce.linearni->citatel < 0)) printf(" - ");
		if (fce.linearni->jmenovatel == 1)
		{
			if (abs(fce.linearni->citatel) == 1)
			{
				printf("x");
			}
			else
			{
				printf("%dx",abs(fce.linearni->citatel));
			}
		}
		else
		{
			if (abs(fce.linearni->citatel) == 1)
			{
				printf("x/%d",fce.linearni->jmenovatel);
			}
			else
			{
				printf("%dx/%d",abs(fce.linearni->citatel),fce.linearni->jmenovatel);
			}
		
		}

	}
	printf("\n");
}


void definuj_otazku(P_OTAZKA otazka)
{

	int i,j,k,l,m,n;
	int tmp_citatel,tmp_jmenovatel;
	P_RACIO tmp_r;

	printf("Začínám definici této otázky.\n");
	printf("Na otázku zatím směřují tyto funkce:\n");
	for (i=0;otazka->pouzite_funkce[i]!=NULL;i++)
	{
		vypis_funkci(*(otazka->pouzite_funkce[i]));
	}
	printf("Vložte 4 primární cíle otázky ve formátu racionálních čísel:\n");

	for (i=0;i<4;i++)
	{
		tmp_jmenovatel = 0;
		tmp_citatel = 0;
		scanf("%d/%d",&tmp_citatel,&tmp_jmenovatel);
		if (tmp_jmenovatel == 0) tmp_jmenovatel = 1;

		tmp_r = r_create(tmp_citatel,tmp_jmenovatel);
	//	r_print(tmp_r);
		otazka->odkazy[i] = tmp_r;
	}

	printf("Vložte 4 funkce ve formátu a^x + b + cx:\n");
	for (i=0;i<4;i++)
	{

		printf("Vložte základ pro exponenciálu, nulu pro vyřazení:\n");
		scanf("%d",&otazka->funkce[i].zaklad);
		printf("Vložte konstantu ve formátu racionálního čísla:\n");
		otazka->funkce[i].konstanta = r_alloc();
		scanf("%d/%d",&otazka->funkce[i].konstanta->citatel, &otazka->funkce[i].konstanta->jmenovatel);
		if (otazka->funkce[i].konstanta->jmenovatel == 0)
		{
			otazka->funkce[i].konstanta->jmenovatel = 1;
		}
		printf("Vložte koeficient lineárního členu ve formátu racionálního čísla:\n");
		otazka->funkce[i].linearni = r_alloc();
		scanf("%d/%d",&otazka->funkce[i].linearni->citatel, &otazka->funkce[i].linearni->jmenovatel);
		if (otazka->funkce[i].linearni->jmenovatel == 0)
		{
			otazka->funkce[i].linearni->jmenovatel = 1;
		}
	}
	otazka->defined = 1;
}

void deklaruj()
{
	
}

int start;
int i,j,k,l,m,n;
int id;
int tmp_citatel,tmp_jmenovatel;

P_RACIO cislo_otazky;

P_RACIO tmp_r;
char y;

int main(int argc, char** argv)
{
	cislo_otazky = r_create(0,1);
	pole[0] = malloc(sizeof(T_OTAZKA));

	pole[0]->id = r_create(1,1);

	pole[0]->defined = 0;
	deklarovanych_otazek = 1;
	definovanych_otazek = 0;
	start = 1;

	do
	{
		printf("--------------------------------------\n");
		if (start)
		{
			start = 0;
		}
		else
		{
			printf("Definice otázky číslo ");
			r_print(cislo_otazky);
			printf(":\n");

			id = poloha(cislo_otazky);
			if (pole[id]->defined)
			{
				for (i=0;i<4;i++)
				{
					r_print(pole[id]->odkazy[i]);
					printf("\t");
					vypis_funkci(pole[id]->funkce[i]);
					printf("\n");
				}
				printf("Upravit definici této otázky (Ano)/(Ne)?\n");
				do
				{
					scanf("%c",&y);
				}
				while((y != 'A') && (y != 'N') && (y != 'a') && (y != 'n'));
				
				if ((y == 'A') || (y == 'a')) definuj_otazku(pole[id]);
			

			}
			else
			{
				printf("Otázka ještě nebyla definována.\n");
				definuj_otazku(pole[id]);
				definovanych_otazek++;

			}
			pole[0]->pouzite_funkce[0] = malloc(sizeof(T_FUNKCE));
			pole[0]->pouzite_funkce[0]->vyrizena = 0;
			pole[0]->pouzite_funkce[0]->zaklad = 0;
			pole[0]->pouzite_funkce[0]->konstanta = 0;
			pole[0]->pouzite_funkce[0]->linearni = r_create(1,1);
			
		}

		printf("Zatím existující otázky jsou:\n");
		for (i=0;i<deklarovanych_otazek;i++)
		{
			r_print(pole[i]->id);
			printf("\n");
		}
		printf("\n");
		printf("Ještě nebyly definované otázky:\n");
		for (i=0;i<deklarovanych_otazek;i++)
		{
			if (pole[i]->defined) continue;
			r_print(pole[i]->id);
			printf("\n");
		}
		printf("\n");
		printf("Celkem nedefinovaných otázek: %d\n",deklarovanych_otazek - definovanych_otazek);
		printf("Celkem otázek: %d\n",deklarovanych_otazek);
	
		printf("Definici další otázky započnete zadáním jejího čísla.\nZadáním čísla, jež nemá otázku, ukončíte program:\n");
	
		scanf("%d/%d",&(cislo_otazky->citatel),&(cislo_otazky->jmenovatel));
		if (cislo_otazky->jmenovatel == 0) cislo_otazky->jmenovatel = 1;
	}
	while (poloha(cislo_otazky) != -1);
	






















	/*
	 *

	while((a = r_create((random()%2000),(random()%2000)))==NULL);
	r_print(a);
	printf("\n");
	r_zkrat(a);
	r_print(a);
	printf("\n");

	while((b = r_create((random()%2000),(random()%2000)))==NULL);
	r_print(b);
	printf("\n");
	r_zkrat(b);
	r_print(b);
	printf("\n");

	if ((c = r_mul(a,b)) != NULL)
	{
		r_print(c);
	}
	else
	{
		printf("Přetečení\n");
	}
	printf("\n");
	
	if((c = r_add(a,b)) != NULL)
	{
		r_print(c);
	}
	else
	{
		printf("Přetečení\n");
	}
	printf("\n");
	*/
	printf("\n");
}
