#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/time.h>

#define DEFAULT_LONGINESS 100

#define MAX_WORD_LENGTH	5
#define MIN_WORD_LENGTH 1

//#define CONSONANTS "qwrtzpsdfghjklcvbnm"
#define CONSONANTS "rtzpsdhjklcvbnm"
#define VOWELS "aeiouylr"

#define FIRST_CONSONANT_PROBAB	0.9
#define SECOND_CONSONANT_PROBAB 0.4

int longiness;
int i;

struct timeval current_time;
struct timezone tz;

char generate_char(const char * PATTERN)
{
	return PATTERN[(int)((((double)random())/RAND_MAX)*(strlen(PATTERN)+1)-0.5 )];
}

char * generate_syllable(void)
{
	int i;
	static char *string;
	if (string) free(string);
	string = malloc(4*sizeof(char));
	i = 0;
	if (((double)random())/RAND_MAX <= FIRST_CONSONANT_PROBAB)
	{
		string[i] = generate_char(CONSONANTS);
		i++;
	}
	if (((double)random())/RAND_MAX <= 1)
	{
		string[i] = generate_char(VOWELS);
		i++;
	}
	if (((double)random())/RAND_MAX <= SECOND_CONSONANT_PROBAB)
	{
		string[i] = generate_char(CONSONANTS);
		i++;
	}
	string[i] = 0;
	return string;
}

char * generate_word(int length)
{
	int i;
	static char * string;
	if (string) free(string);
	string = malloc(length*4*sizeof(char));
	for (i=0;i<length;i++)
		strcat(string,generate_syllable());
	return string;
}

int main(int argc, char ** argv)
{
	gettimeofday(&current_time, &tz);
	srand(current_time.tv_usec);
	if (argc == 1)
		longiness = DEFAULT_LONGINESS;
	else
		longiness = atoi(argv[1]);

	for (i=0;i<longiness;i++)
	{
		printf("%s ",generate_word(rint((((double)random())/((double)RAND_MAX))*(MAX_WORD_LENGTH-MIN_WORD_LENGTH)+MIN_WORD_LENGTH)));
	}
	printf("\n");
}
