#include <stdio.h>
#include <stdlib.h>
#include "sqrt.h"

#define VRCHOLU		285
#define MAX_ITER	1000
#define A		15
#define B		19

#define illegal(x,y)	(!legal(x,y))
#define legal(x,y)	((x > -1) && (x < A) && (y > -1) && (y < B))
#define POSTSCRIPT
//#define STANDARD
//#define DEBUG

typedef struct vrchol {
	int oznaceni;
	int x,y;
	struct vrchol *sousede[50];
	int pocet_sousedu;
} T_VRCHOL, *P_VRCHOL;

typedef struct result {
	double real;
	double system;
} T_RESULT, *P_RESULT;

T_VRCHOL vrcholy[VRCHOLU];
P_VRCHOL vrcholy_sorted[VRCHOLU];
char pom_string[50];
FILE *fp;
int pom_char;
P_VRCHOL cur_vrchol;
int pom_int;
P_RESULT pom_res;
int i,j,k,l,m;
int x1,y1,x2,y2;
double sum_total = 0;
P_RESULT sum_max;
P_RESULT sumy[VRCHOLU];
int smer;
double pom_double;
int moved;
int step;

P_VRCHOL tabulka[A][B];

static int cmp(const void *p1, const void *p2)
{
	return -( (*(P_VRCHOL*)p1)->pocet_sousedu - (*(P_VRCHOL*)p2)->pocet_sousedu) ;
}


void vypis(void)
{

#ifdef POSTSCRIPT
	printf("0.01 setlinewidth 60 60 translate 35 35 scale\n");
#endif
	
	for (i=0;i<VRCHOLU;i++)
	{
#ifdef STANDARD
		printf("%d %d : %d\n",vrcholy[i].x,vrcholy[i].y,i);
		for (j=0;j<vrcholy[i].pocet_sousedu;j++)
		{
			printf("\t%d %d : %d\n",vrcholy[i].sousede[j]->x,vrcholy[i].sousede[j]->y,j);
		}
#endif
#ifdef POSTSCRIPT
		for (j=0;j<vrcholy[i].pocet_sousedu;j++)
		{
			printf("newpath %d %d moveto %d %d lineto stroke %%%d -- %d\n",
					vrcholy[i].x,
					vrcholy[i].y,
					vrcholy[i].sousede[j]->x,
					vrcholy[i].sousede[j]->y,
					i,
					j
					);
		}
#endif

	}
}

double vzdalenostxy(double x1, double y1, double x2, double y2)
{
	return sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
}

double vzdalenost(P_VRCHOL a, P_VRCHOL b)
{
	if (b == NULL) return 0;
	if (a == NULL) return 0;
	double c;
	c = vzdalenostxy(a->x,a->y,b->x,b->y);
	return c;
}
P_RESULT checkswitch (int x1, int y1, int x2, int y2)
{
	P_RESULT result;
	P_VRCHOL a;
	P_VRCHOL b;

	int i;
	double now_sum = 0;
	double after_sum = 0;
	double c,d;

	result = malloc(sizeof(T_RESULT));
	if (illegal(x1,y1) || illegal(x2,y2))
	{
		result->real = sum_total + 30;
		result->system = sum_total + 30;
		return result;
	}
//	fprintf(stderr,"%d %d %d %d\n",x1,y1,x2,y2);

	if (x1 + y1 > x2 + y2)
	{
		a = tabulka[x1][y1];
		b = tabulka[x2][y2];
	}
	else
	{
		b = tabulka[x1][y1];
		a = tabulka[x2][y2];
	}
//	fprintf(stderr,"%d %d\n",a,b);
	for (i=0;i<a->pocet_sousedu;i++)
	{
		if (a->sousede[i] == b || a->sousede[i] == a) continue;
		c = vzdalenost(a,a->sousede[i]);
		d = vzdalenost(b,a->sousede[i]);
//		fprintf(stderr,"%d %d %d %lf %lf\n",i,x1,y1,c,d);
		if ((c == 0) || (d == 0)) continue;
		now_sum += c;
		after_sum += d;
	}
	result->system = (sum_total - now_sum + after_sum);
	for (i=0;i<b->pocet_sousedu;i++)
	{
		if (b->sousede[i] == a || b->sousede[i] == b) continue;
		c = vzdalenost(b,b->sousede[i]);
		d = vzdalenost(a,b->sousede[i]);
//		fprintf(stderr,"%d %d %d %lf %lf\n",i,x2,y2,c,d);
		if ((c == 0) || (d == 0)) continue;
		now_sum += c;
		after_sum += d;
	}

//	result->system = (sum_total - now_sum + after_sum);
	result->real = (sum_total - now_sum + after_sum);
	return result;
	
}

double get_total_sum(void)
{
	int i;
	double sum_total = 0,pom_double;
	for (i=0;i<VRCHOLU;i++)
	{
		for (j=0;j<vrcholy[i].pocet_sousedu;j++)
		{
			pom_double = vzdalenost(vrcholy[i].sousede[j],&vrcholy[i]);
//			fprintf(stderr,"\t%d %d\t%lf\n",i,j,pom_double);
			sum_total += pom_double;
		}
	}
	return sum_total;
}


int main()
{
//	fprintf(stderr,"%lf %lf %lf %lf %lf %lf\n",sqrt(2),sqrt(3),sqrt(4),sqrt(5),sqrt(6),sqrt(-1));
	fp = fopen("lab-graph","r");
	cur_vrchol = NULL;
	pom_char = 1;
	while (!feof(fp))
	{
		do
		{
			pom_char = getc(fp);
		}
		while (pom_char == 10);
		if (feof(fp)) break;

		if (pom_char == '\t')
		{
			ungetc(pom_char,fp);
			fscanf(fp,"%d",&pom_int);
			pom_int --;
			if (cur_vrchol != NULL)
			{
				cur_vrchol->sousede[cur_vrchol->pocet_sousedu] = vrcholy + pom_int;
				cur_vrchol->pocet_sousedu++;
			}
			else
			{
				exit;
			}
		}
		else
		{
			ungetc(pom_char,fp);
			fscanf(fp,"%d",&pom_int);
			pom_int --;
			cur_vrchol = vrcholy + pom_int;
			cur_vrchol->pocet_sousedu = 0;
//			cur_vrchol->x = pom_int % A;
//			cur_vrchol->y = pom_int / A;
//			tabulka[cur_vrchol->x][cur_vrchol->y] = cur_vrchol;
	//		fprintf(stderr,"\t%d %d\n",tabulka[cur_vrchol->x][cur_vrchol->y]->x,tabulka[cur_vrchol->x][cur_vrchol->y]->y);
		}
	}
	for (i=0;i<VRCHOLU;i++)
	{
		vrcholy_sorted[i] = &vrcholy[i];
	}

	qsort(vrcholy_sorted,VRCHOLU,sizeof(P_VRCHOL),&cmp);
	smer = 0;
	x1 = 0;
	y1 = 0;

	for (i=0;i<VRCHOLU;i++)
	{
		vrcholy_sorted[i]->x = x1;
		vrcholy_sorted[i]->y = y1;
		tabulka[x1][y1] = vrcholy_sorted[i];
#ifdef DEBUG
		fprintf(stderr,"\t\t\t%d %d\n",x1,y1);
#endif

		switch(smer)
		{
			case 0:
				x1++;
				if((tabulka[x1][y1] != NULL) || (x1 == A))
				{
					x1--;
					smer++;
				}
				else
				{
					break;
				}
			case 1:
				y1++;
				if((tabulka[x1][y1] != NULL) || (y1 == B))
				{
					y1--;
					smer++;
				}
				else
				{
					break;
				}
			case 2:
				x1--;
				if((tabulka[x1][y1] != NULL) || (x1 == -1))
				{
					x1++;
					smer++;
				}
				else
				{
					break;
				}
			case 3:
				y1--;
				if((tabulka[x1][y1] != NULL) || (y1 == -1))
				{
					y1++;
					smer = 0;
				}
				else
				{
					break;
				}
			default:
				x1++;
				break;

		}
	}
	sum_total = get_total_sum();

#ifdef DEBUG
	fprintf(stderr,"%lf\n",sum_total);
#endif
	moved = -1;
	for (i=0;i<MAX_ITER;i++)
	{
		
		moved = 0;
		for (j=0;j<VRCHOLU;j++)
		{
#ifdef DEBUG
			fprintf(stderr,"%d %d\n",i,j);
#endif
			sum_max = malloc(sizeof(T_RESULT));
			sum_max->real = sum_total;
			sum_max->system = sum_total;
			for (k=0;k<VRCHOLU;k++)
			{
				if (j == k) continue;
				sumy[0] = checkswitch(vrcholy_sorted[j]->x,vrcholy_sorted[j]->y,vrcholy_sorted[k]->x,vrcholy_sorted[k]->y); // vlevo
				if ((((i + j)%A == 0) ? sumy[0]->real : sumy[0]->system) < (((i + j)%A == 0) ? sum_max->real : sum_max->system))
				{
					m = k;
					free(sum_max);
					sum_max = sumy[0];
				}
				else
				{
					free(sumy[0]);
				}
//				fprintf(stderr,"\t%lf\n",sum_total);

			}
			if (sum_max->real < sum_total)
			{
				x1 = vrcholy_sorted[j]->x;
				y1 = vrcholy_sorted[j]->y;
				x2 = vrcholy_sorted[m]->x;
				y2 = vrcholy_sorted[m]->y;
				cur_vrchol = tabulka[x1][y1];
				tabulka[x1][y1] = tabulka[x2][y2];
				tabulka[x2][y2] = cur_vrchol;
				tabulka[x1][y1]->x = x1;
				tabulka[x1][y1]->y = y1;
				tabulka[x2][y2]->x = x2;
				tabulka[x2][y2]->y = y2;
				moved++;
				sum_total = sum_max->real;
			}
			free(sum_max);
//			fprintf(stderr,"\t%lf\n",sum_total - get_total_sum());
		}
		
/*		for (j=0;j<A;j++)
		{
			for (k=0;k<B;k++)
			{
				step = (i+j+k)%12 + 1;
				sumy[0] = checkswitch(j,k,j-step,k); // vlevo
				sumy[1] = checkswitch(j,k,j+step,k); // vpravo
				sumy[2] = checkswitch(j,k,j,k-step); // dolů
				sumy[3] = checkswitch(j,k,j,k+step); // vzhůru
#ifdef DEBUG
				fprintf(stderr,"%d %d %d %d\n",i,j,k,step);
#endif
				smer = -1;
				for (l=0;l<4;l++)
				{
//					fprintf(stderr,"%lf\n",sumy[l]);
					if (
							(
							 (smer == -1)
							 	? sum_total
								: (
									((i + j + k)%A == 0)
										? sumy[smer]->real
										: sumy[smer]->system
								)
							)
							>
							(
							 ((i + j + k)%A == 0)
							 	? sumy[l]->real
								: sumy[l]->system
							)
					)
					{
						smer = l;
					}
				}

#ifdef DEBUG
				fprintf(stderr,"\t\t%d",smer);
#endif
//				fprintf(stderr,"\t\t\t%lf %lf %lf %lf %lf",sumy[0],sumy[1],sumy[2],sumy[3])


				switch(smer)
				{
					case 3:cur_vrchol = tabulka[j][k+step];
					       tabulka[j][k+step] = tabulka[j][k];
					       tabulka[j][k] = cur_vrchol;
					       tabulka[j][k+step]->x = j;
					       tabulka[j][k+step]->y = k+step;
					       tabulka[j][k]->x = j;
					       tabulka[j][k]->y = k;
					       moved++;
					       break;
					case 2:cur_vrchol = tabulka[j][k-step];
					       tabulka[j][k-step] = tabulka[j][k];
					       tabulka[j][k] = cur_vrchol;
					       tabulka[j][k-step]->x = j;
					       tabulka[j][k-step]->y = k-step;
					       tabulka[j][k]->x = j;
					       tabulka[j][k]->y = k;
					       moved++;
					       break;
					case 1:cur_vrchol = tabulka[j+step][k];
					       tabulka[j+step][k] = tabulka[j][k];
					       tabulka[j][k] = cur_vrchol;
					       tabulka[j+step][k]->x = j+step;
					       tabulka[j+step][k]->y = k;
					       tabulka[j][k]->x = j;
					       tabulka[j][k]->y = k;
					       moved++;
					       break;
					case 0:cur_vrchol = tabulka[j-step][k];
					       tabulka[j-step][k] = tabulka[j][k];
					       tabulka[j][k] = cur_vrchol;
					       tabulka[j-step][k]->x = j-step;
					       tabulka[j-step][k]->y = k;
					       tabulka[j][k]->x = j;
					       tabulka[j][k]->y = k;
					       moved++;
					       break;
				}
//				sum_total = get_total_sum();
				sum_total = ((smer == -1) ? sum_total : sumy[smer]->real);
#ifdef DEBUG
				fprintf(stderr,"\t%lf\n",sum_total);
#endif
				for (l=0;l<4;l++)
				{
					free(sumy[l]);
				}

			}
		}*/

//#ifdef DEBUG
		fprintf(stderr,"%lf\n",sum_total);
//#endif
		if (moved == 0) break;
	}
	vypis();
}

