#define MAXINT	(1<<30)

typedef struct racio {
	int citatel;
	int jmenovatel;
} T_RACIO, *P_RACIO;

long int mcdl(long int a, long int b);
int mcd(int a, int b);
void r_zkrat(P_RACIO a);
P_RACIO r_alloc(void);
P_RACIO r_create(int citatel, int jmenovatel);
P_RACIO r_add(P_RACIO a, P_RACIO b);
P_RACIO r_mul(P_RACIO a, P_RACIO b);
void r_print(P_RACIO a);
int r_cmp(P_RACIO a, P_RACIO b);


long int mcdl(long int a, long int b)
{
	int zn = 1;
	if (b == 0) return -1;
	if (a == 0) return -1;
	zn = abs(b)/b;
	a = abs(a);
	b = abs(b);
	while (a != b)
	{
		if (a > b)
		{
			a -= b;
		}
		else
		{
			b -= a;
		}
	}
	return a*zn;
	
}

int mcd(int a, int b)
{
	return (int) mcdl((long int) a, (long int) b);
}

void r_zkrat(P_RACIO a)
{
	int m;
	if (a->citatel == 0)
	{
		a->jmenovatel = 1;
		return;
	}
	if (a->jmenovatel == 0)
	{
		a->citatel = 0;
		return;
	}
	m = mcd(a->citatel,a->jmenovatel);
	a->citatel /= m;
	a->jmenovatel /= m;
}

P_RACIO r_alloc(void)
{
	return malloc(sizeof(T_RACIO));
}

P_RACIO r_create(int citatel, int jmenovatel)
{
	if (jmenovatel == 0) return NULL;
	P_RACIO out;
	out = malloc(sizeof(T_RACIO));
	out->citatel = citatel;
	out->jmenovatel = jmenovatel;
	return out;
}


P_RACIO r_add(P_RACIO a, P_RACIO b)
{
	P_RACIO out;
	long int jmenovatel;
	long int citatel;
	long int m;
	
	jmenovatel = a->jmenovatel * b->jmenovatel;
	citatel = a->jmenovatel*b->citatel + b->jmenovatel*a->citatel;
	
	m = mcdl(citatel, jmenovatel);

	jmenovatel /= m;
	citatel /= m;
	if ((citatel > MAXINT) || (jmenovatel > MAXINT)) return NULL;

	out = malloc(sizeof(T_RACIO));
	out->jmenovatel = (int) jmenovatel;
	out->citatel = (int) citatel;

	return out;
	
}

P_RACIO r_sub(P_RACIO a, P_RACIO b)
{
	P_RACIO out;
	b->citatel = -(b->citatel);
	out = r_add(a,b);
	b->citatel = -(b->citatel);
	return out;
}

P_RACIO r_mul(P_RACIO a, P_RACIO b)
{
	P_RACIO out;
	long int citatel;
	long int jmenovatel;
	long int m;

	citatel = a->citatel * b->citatel;
	jmenovatel = a->jmenovatel * b->jmenovatel;

	m = mcdl(citatel, jmenovatel);

	jmenovatel /= m;
	citatel /= m;

	if ((citatel > MAXINT) || (jmenovatel > MAXINT)) return NULL;

	out = malloc(sizeof(T_RACIO));
	out->jmenovatel = (int) jmenovatel;
	out->citatel = (int) citatel;

	return out;
	
}

void r_print(P_RACIO a)
{
	printf("%d/%d",a->citatel,a->jmenovatel);
}

int r_cmp(P_RACIO a, P_RACIO b)
{
	r_zkrat(a);
	r_zkrat(b);
	if ((a->citatel == b->citatel) && (a->jmenovatel == b->jmenovatel)) return 0;
	
	return r_sub(a,b)->citatel;
}
